#include <AI8051U.H>
#include "UART2.h"

void main(void)
{
	P_SW2 = 0x80;		//使能XFR，没有冲突不用关闭
	CKCON = 0x00;		//设置外部数据总线速度为最快
	WTST = 0x00;		//设置程序代码等待参数
						//赋值为0可将CPU执行程序的速度设置为最快
	P0M1 = 0x00;	P0M0 = 0x00;	//配置P0口为准双向口
	P1M1 = 0x00;	P1M0 = 0x00;	//配置P1口为准双向口
	P2M1 = 0x00;	P2M0 = 0x00;	//配置P2口为准双向口
	P3M1 = 0x00;	P3M0 = 0x00;	//配置P3口为准双向口
	P4M1 = 0x00;	P4M0 = 0x00;	//配置P4口为准双向口
	P5M1 = 0x00;	P5M0 = 0x00;	//配置P5口为准双向口
	
	Uart2_Init();
	IE2 |= 0x01;	//ES2 = 1;使能串口2中断
	EA = 1;			//使能总中断
	Uart2_SendStr("Hello Uart!\r\n");
	
	while(1)
	{
		if(S2_rptr != S2_wptr)
		{
			Uart2_Send(S2_buffer[S2_rptr++]);
			S2_rptr &= 0x0F;
		}
	}
}

void Uart2_Isr(void) interrupt 8
{
	S2_RITI = S2CON;
	if (S2_RITI & 0x02)			//发送中断标志置1时
	{
		S2CON &= ~0x02;			//清零发送中断标志
		S2_busy = 0;				//清零忙状态
	}
	if (S2_RITI & 0x01)			//接收中断标志置1时
	{
		S2CON &= ~0x01;			//清零接收中断标志
		S2_buffer[S2_wptr++] = S2BUF;	//接受长度16
		S2_wptr &= 0x0f;			//接受长度16
	}
	S2_RITI = 0x00;
}
